unit RealEd;

{$IFDEF FPC}
  {$MODE Delphi}
{$ENDIF}

interface

uses
{$IFnDEF FPC}
  Windows,
{$ELSE}
  LCLIntf, LCLType, LMessages,
{$ENDIF}
  Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, Spin, FloatEdit, Menus;

type
  TForm1 = class(TForm)
    Button1: TButton;
    EdWert: TEdit;
    SENk: TSpinEdit;
    NK: TLabel;
    SEL: TSpinEdit;
    SEWert: TSpinEdit;
    Label1: TLabel;
    Edit1: TEdit;
    FE1: TFloatEdit;
    FE2: TFloatEdit;
    FER: TFloatEdit;
    Button2: TButton;
    SED: TSpinEdit;
    EdTZ: TEdit;
    procedure FE1Change(Sender: TObject);
    procedure SENkChange(Sender: TObject);
    procedure SEWertChange(Sender: TObject);
    procedure SELChange(Sender: TObject);
    procedure FE1Enter(Sender: TObject);
    procedure FE1Exit(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure SEDChange(Sender: TObject);
    procedure FormActivate(Sender: TObject);
    procedure FormCreate(Sender: TObject);
  private
    { Private-Deklarationen }
  public
    { Public-Deklarationen }
  end;

  const
    max = 100;
var
  init:boolean;
  Form1: TForm1;
  arr : array[0..max-1] of real;
  n : integer;
  UmlTZ,UmlTZDef : byte;

implementation

uses Unit2;

{$IFnDEF FPC}
  {$R *.dfm}
{$ELSE}
  {$R *.lfm}
{$ENDIF}
procedure TForm1.FE1Change(Sender: TObject);
begin
  FER.Value:=FE1.Value+FE2.Value;
end;

procedure TForm1.SENkChange(Sender: TObject);
begin
  FE1.NK:=SENk.Value;
end;

procedure TForm1.SEWertChange(Sender: TObject);
begin
  FE1.Value:=SEWert.Value;
end;

procedure TForm1.SELChange(Sender: TObject);
begin
  FE1.MaxLength:=SEl.Value;
end;

procedure TForm1.FE1Enter(Sender: TObject);

begin
  inherited;
  Edit1.text:='enter';
end;

procedure TForm1.FE1Exit(Sender: TObject);
begin
  Edit1.text:='exit';
end;

procedure TForm1.Button1Click(Sender: TObject);
begin
  FE1.Value:=11600;
end;


procedure UmluftTZ(ZSTemp : integer);
var
  UmlTZAlt : integer;
begin
    UmlTZAlt:=UmlTZ;
    UmlTzDef:=UmlTZ; { Falls UmlTZDef unten nicht gesetzt }
    { Berechnen der definitiven TZ }
    if ZSTemp<750 then begin { <75 }
      if ZSTemp=0 then UmLTzDef:=0{ Temp 0 macht 0 rpm }
      else UmLTzDef:=2;{ 1000 rpm }
    end
    else begin
      if (ZSTemp>=750) and (ZSTemp<1000) then begin { Hysterese 75..100 }
        if (UmlTzAlt=0) or (UmlTzAlt=2) then UmLTzDef:=2 { von 0 oder 1000 auf 1000}
        else UmlTzDef:=3;{ von 750 oder 1500 auf 1500 }
      end
      else begin
        if (ZSTemp>=1000) and (ZSTemp<5750) then begin { 100..575 immer 1500 rpm }
          UmLTzDef:=3;{ 1500 rpm }
        end
        else begin
          if (ZSTemp>=5750) and (ZSTemp<6000)  then begin { Hysterese 575..600 }
            if (UmlTzAlt=1) or (UmlTzAlt=2) then UmLTzDef:=2 { von 750 oder 1000 auf 1000 }
            else UmLTzDef:=3;{ von 0 oder 1500 auf 1500 }
          end
          else begin
            if (ZSTemp>=6000) and (ZSTemp<7250)  then begin { 600..725 }
              UmLTzDef:=2;{ 1000 rpm }
            end {  }
            else begin  { }
              if (ZSTemp>=7250) and (ZSTemp<7500) then begin { Hysterese 725..750 }
                if UmlTzAlt=1 then UmLTzDef:=1  { 750 bleibt }
                else UmlTZDef:=2;{ von 0, 1500, 1000 auf 1000 }
              end
              else UmLTzDef:=1; { >750: immer 750 rpm }
            end; { }
          end;
        end;
      end; { }
    end; { else<750}
    UmlTz:=UmlTZAlt; { Falls gleich }
    if UmlTzDef>UmlTZAlt then UmlTz:=UmlTZAlt+1; { Nchst hhere TZ }
    if UmlTzDef<UmlTZAlt then UmlTz:=UmlTZAlt-1; { Nchst tiefere TZ }
    if UmlTzDef=0 then UmlTz:=0; { aus }
end;

procedure TForm1.SEDChange(Sender: TObject);
begin
  try
    UmluftTz(SED.Value*10);
    EdTz.Text:=inttostr(UmlTZdef);
  except
  end;  
end;

procedure TForm1.FormActivate(Sender: TObject);
begin

 if init then  Form2.Show;
 init:=false;
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
  init:=true;
end;

end.
